// Com.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#import "..\Codec4800.dll" no_namespace 

#define   FILE_INPUT "orig.pcm"
#define   FILE_COMPRESS "comp48.prm"
#define   FILE_SYNT "synt.pcm"

void Example1();
void Example2();

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	bool bUseExample1 = true;

	if(FAILED(OleInitialize(0)))
		return 0;

	try
	{
		if(bUseExample1)
			Example1();
		else
			Example2();
	}
	catch(_com_error& err)
	{
		HRESULT errorCode = err.Error();
	}

	return 1;
}
// frame by frame encoding and decoding

void Example1()
{
	ICodec4800Ptr	m_Codec;
	if(FAILED(m_Codec.CreateInstance("VIMAS.Codec4800")))
		return;

	m_Codec->Encode(FILE_INPUT, FILE_COMPRESS, 50);

//	m_Codec->Reset();

	m_Codec->Decode(FILE_COMPRESS, FILE_SYNT, false);
}

void EncodeUsingSafeArray(ICodec4800Ptr& codec, const char* strFileInput, const char* strFileCompress);
void DecodeUsingSafeArray(ICodec4800Ptr& codec, const char* strFileInput, const char* strFileSynt);
_variant_t CreateSafeArray(int ElemType, int ArrSize);

//  file encoding and decoding 
void Example2()
{
	ICodec4800Ptr	m_Codec;
	if(FAILED(m_Codec.CreateInstance("VIMAS.Codec4800")))
		return;

	EncodeUsingSafeArray(m_Codec, FILE_INPUT, FILE_COMPRESS);

	m_Codec->Reset();

	DecodeUsingSafeArray(m_Codec, FILE_COMPRESS, FILE_SYNT);
}


void EncodeUsingSafeArray(ICodec4800Ptr& codec, const char* strFileInput, const char* strFileCompress)
{
	FILE  *fin,*fcomp; 
    long i;
    long  NF;
//	short vad;
	short Frame = codec->FrameSize / sizeof(short);
	short CodedFrameSize = codec->CodedFrameSize / sizeof(char);

	_variant_t Input = CreateSafeArray(VT_I2, Frame);
	_variant_t CodedFrame = CreateSafeArray(VT_UI1, CodedFrameSize);

	if( (fin=fopen(strFileInput,"rb"))==NULL)
	{
		printf("Can not open input file\n");
	    return;
	}

  // Calculate the number of frames in the file
    fseek(fin, 0L, SEEK_END);
    NF = ftell(fin);
    rewind(fin);
    NF /= sizeof(short)*Frame ;
//    printf("Frames in file  %d \n", NF);
    

    fcomp=fopen(strFileCompress,"wb");
    

    // Do compression 

    for( i=0; i<NF; i++ )
	{

	  fread (Input.parray->pvData, sizeof(short), Frame, fin);

	   VARIANT_BOOL bSpeech = codec->Encode(Input, CodedFrame, 50 ); 

       fwrite(CodedFrame.parray->pvData, sizeof(char), CodedFrameSize, fcomp);

//       printf("Processed frames  %d \r", i);
    }

  fclose(fcomp); 
  fclose(fin);

}

void DecodeUsingSafeArray(ICodec4800Ptr& codec, const char* strFileInput, const char* strFileSynt)
{
    FILE  *fin, *fout;      
    long i;
    long  NF;
	short Frame = codec->FrameSize / sizeof(short);
	short CodedFrameSize = codec->CodedFrameSize / sizeof(char);

	_variant_t Output = CreateSafeArray(VT_I2, Frame);
	_variant_t FrameSynt = CreateSafeArray(VT_UI1, CodedFrameSize);

	if( (fin=fopen(strFileInput,"rb"))==NULL)
	{
		printf("Can not open input file\n");
		return;
	}

  // Calculate the number of frames in the file
    fseek(fin, 0L, SEEK_END);
    NF = ftell(fin);
    rewind(fin);
    NF /= CodedFrameSize ;
    printf("Frames in file  %d \n", NF);
    


	fout=fopen(strFileSynt,"wb");
    
  // Init  decoder
   // InitDecoder();

  // Do decompression

     for( i=0; i<NF; i++ )
	 {

       fread (FrameSynt.parray->pvData, sizeof(char), CodedFrameSize, fin);

	   codec->Decode(FrameSynt, Output,  0) ;

	   fwrite(Output.parray->pvData, sizeof(short), Frame,fout);

//       printf("Processed frames  %d \r", i);
     }

     fclose(fin);
     fclose(fout); 

}

_variant_t CreateSafeArray(int ElemType, int ArrSize)
{
	_variant_t array;
	array.vt = ElemType | VT_ARRAY;
	SAFEARRAYBOUND bound;
	bound.lLbound = 0;
	bound.cElements = ArrSize;
	array.parray = SafeArrayCreate(ElemType, 1, &bound );
	return array;
}

